#tag Class
Protected Class LDS_DesktopWindowMenuItem
Inherits DesktopMenuItem
Implements LDS_DarkModeResponsive
	#tag Event
		Sub MenuBarSelected()
		  if(me.specialMenuType=LDS_DesktopWindowMenuItem.specialMenuItemTypes.RootLevel) then
		    //system.DebugLog("Hello from ROOT LDS_DesktopWindowMenuItem MenuBarSelected event")
		    updateMenu()
		    
		    'if(app.WindowCount>0 and app.window(0)=LDS_DesktopWindowListable.topWindow) then
		    'FileClose.Enabled = True
		    'else
		    'if(app.WindowCount>0 and not app.window(0) isa LDS_DesktopWindowListable) then
		    'FileClose.Enabled = True
		    'else
		    'FileClose.Enabled = False
		    'end
		    'end
		    
		  else
		    //system.DebugLog("Hello from aChild LDS_DesktopWindowMenuItem MenuBarSelected event")
		  end
		  
		End Sub
	#tag EndEvent

	#tag Event
		Function MenuItemSelected() As Boolean
		  // Show the window associated with this MenuItem
		  var theWin as DesktopWindow
		  if(not App.windowAt(0) isa LDS_DesktopWindowListable) then 
		    theWin = app.WindowAt(0)
		  else
		    if(LDS_DesktopWindowListable.WindowList.Count>0) then
		      theWin = DesktopWindow(LDS_DesktopWindowListable.WindowList(0))
		    end 
		  end
		  
		  if(specialMenuType=specialMenuItemTypes.NOT_SPECIAL) then
		    mWindow.Show
		  end
		  if(specialMenuType=specialMenuItemTypes.Minimize) then
		    theWin.Minimize
		  end
		  if(specialMenuType=specialMenuItemTypes.Zoom) then
		    theWin.Maximize
		  end
		  
		  if(specialMenuType=specialMenuItemTypes.BringAllToFront) then
		    var windowList() as DesktopWindow
		    redim windowList(-1)
		    
		    for ix as integer = app.WindowCount-1 downto 0 // restore in reverse order to keep the layering unchanged
		      windowList.Add(app.WindowAt(ix))
		      system.DebugLog("To Restore AppWin ("+ix.tostring+") = '"+app.WindowAt(ix).Title+"'")
		    next
		    if(App.windowAt(0) isa LDS_DesktopWindowListable) then 
		      for ix as integer = LDS_DesktopWindowListable.WindowList.LastIndex downto 0
		        windowList.Add(desktopWindow(LDS_DesktopWindowListable.WindowList(ix)))
		        system.DebugLog("To Restore LDSWin ("+ix.tostring+") = '"+LDS_DesktopWindowListable.WindowList(ix).Title+"'")
		      next
		    end
		    for each aWin as desktopWindow in windowList
		      aWin.show()
		    next
		  end
		End Function
	#tag EndEvent


	#tag Method, Flags = &h0
		Shared Sub addMenuForWindow(win as LDS_DesktopWindowListable)
		  if(myRoot<>nil) then
		    var wm as LDS_DesktopWindowMenuItem = new LDS_DesktopWindowMenuItem(win)
		    DesktopMenuItem(myRoot).AddMenu(wm)
		  end
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub AppearanceChanged()
		  // Part of the LDS_DarkModeResponsive interface.
		  
		  updateMenu()
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h1
		Protected Shared Sub clearSpecialMenus()
		  if(myRoot<>nil) then
		    var index as integer = 0
		    while (index<=(myRoot.count-1)) 
		      if(not (myRoot.MenuAt(index) isa LDS_DesktopWindowMenuItem) or ( LDS_DesktopWindowMenuItem(myRoot.MenuAt(index)).specialMenuType <> LDS_DesktopWindowMenuItem.specialMenuItemTypes.NOT_SPECIAL)) then
		        myRoot.RemoveMenuAt(index)
		      else
		        index=index+1
		      end
		    wend
		  end
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Sub configureWindowMenu(configuration as integer)
		  if(myRoot<>nil) then
		    var menuIndex as integer = 0
		    clearSpecialMenus()
		    #if targetMacOS then
		      if(bitwise.bitAnd(configuration,integer(specialMenuConfiguration.minimize))<>0 ) then
		        
		        var mi_min as LDS_DesktopWindowMenuItem = new LDS_DesktopWindowMenuItem(specialMenuItemTypes.Minimize)
		        myRoot.AddMenuAt(menuIndex,mi_min)
		        menuIndex=menuIndex+1
		      end
		      if(bitwise.bitAnd(configuration,integer(specialMenuConfiguration.zoom))<>0 ) then
		        
		        var mi_zoom as LDS_DesktopWindowMenuItem = new LDS_DesktopWindowMenuItem(specialMenuItemTypes.Zoom)
		        myRoot.AddMenuAt(menuIndex,mi_zoom)
		        menuIndex=menuIndex+1
		      end
		      if(bitwise.bitAnd(configuration,(integer(specialMenuConfiguration.minimize)+integer(specialMenuConfiguration.zoom)))<>0 ) then
		        var mi_div as DesktopMenuItem = new DesktopMenuItem("-")
		        myRoot.AddMenuAt(menuIndex,mi_div)
		        menuIndex=menuIndex+1
		      end
		      'if(includeToOtherMonitors) then
		      '
		      'end
		      if(bitwise.bitAnd(configuration,integer(specialMenuConfiguration.BringToFront))<>0 ) then
		        var mi_front as LDS_DesktopWindowMenuItem = new LDS_DesktopWindowMenuItem(specialMenuItemTypes.BringAllToFront)
		        myRoot.AddMenuAt(menuIndex,mi_front)
		        menuIndex=menuIndex+1
		        
		        var mi_div as DesktopMenuItem = new DesktopMenuItem("-")
		        myRoot.AddMenuAt(menuIndex,mi_div)
		        menuIndex=menuIndex+1
		      end
		    #endif
		  end
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Function configureWindowMenu(config1 as LDS_DesktopWindowMenuItem.specialMenuConfiguration, config2 as LDS_DesktopWindowMenuItem.specialMenuConfiguration = LDS_DesktopWindowMenuItem.specialMenuConfiguration.none, config3 as LDS_DesktopWindowMenuItem.specialMenuConfiguration = LDS_DesktopWindowMenuItem.specialMenuConfiguration.none, config4 as LDS_DesktopWindowMenuItem.specialMenuConfiguration = LDS_DesktopWindowMenuItem.specialMenuConfiguration.none) As integer
		  var configValue as integer = integer(config1)+integer(config2)+integer(config3)+integer(config4)
		  configureWindowMenu(configValue)
		  return configValue
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Constructor(w as LDS_DesktopWindowListable)
		  // Calling the overridden superclass constructor.
		  Super.Constructor
		  
		  // Save the window associated with the MenuItem
		  mWindow = w
		  me.Text = w.Title
		  me.specialMenuType= specialMenuItemTypes.NOT_SPECIAL
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Constructor(specialMenuCode as specialMenuItemTypes = specialMenuItemTypes.RootLevel)
		  // Calling the overridden superclass constructor.
		  Super.Constructor
		  
		  me.specialMenuType = specialMenuCode
		  if(specialMenuCode=specialMenuItemTypes.RootLevel) then
		    mWindow = nil
		    me.Text = "Window"
		    me.AutoEnabled = true
		    myRoot=me
		  end
		  if(specialMenuCode=specialMenuItemTypes.Minimize) then
		    mWindow = nil
		    me.Text = "Minimize"
		    me.AutoEnabled = false
		  end
		  if(specialMenuCode=specialMenuItemTypes.Zoom) then
		    mWindow = nil
		    me.Text = "Zoom"
		    me.AutoEnabled = false
		  end
		  if(specialMenuCode=specialMenuItemTypes.BringAllToFront) then
		    mWindow = nil
		    me.Text = "Bring All to Front"
		    me.AutoEnabled = false
		  end
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Function diamondHiddenWindow() As boolean
		  return mDiamondHiddenWindow
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Sub diamondHiddenWindow(assigns value as boolean)
		  mDiamondHiddenWindow = value
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Function getMenuItemforWindow(win as DesktopWindow) As DesktopMenuItem
		  if(myRoot<>nil) then
		    for ix as integer = 0 to myRoot.Count-1
		      if(myRoot.MenuAt(ix) isa LDS_DesktopWindowMenuItem and LDS_DesktopWindowMenuItem(myRoot.MenuAt(ix)).IsWindow(win)) then
		        return myRoot.MenuAt(ix)
		      end
		    next
		  end
		  return nil
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function IsWindow(w as DesktopWindow) As Boolean
		  // Return true if this is the window they are
		  // looking for
		  if(me.specialMenuType<>specialMenuItemTypes.NOT_SPECIAL) then return false
		  Return (mWindow = w)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Sub removeMenuForWindow(win as LDS_DesktopWindowListable)
		  if(myRoot<>nil) then
		    for  childIndex as integer = 0 to myRoot.count-1
		      if(myRoot.MenuAt(childIndex) isA LDS_DesktopWindowMenuItem) then
		        var w as LDS_DesktopWindowMenuItem = LDS_DesktopWindowMenuItem(myRoot.MenuAt(childIndex))
		        if(w.specialMenuType = specialMenuItemTypes.NOT_SPECIAL and w.isWindow(win)) then
		          myRoot.RemoveMenuAt(childIndex)
		          exit
		        end
		      end
		    next
		  end
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h1
		Protected Shared Sub updateMenu()
		  // Set Checked = True for the current window
		  // Only the top-most window calls this event, so
		  // we first uncheck all the MenuItems and then just
		  // check the one that matches this window.
		  
		  Var count As Integer
		  Var w As LDS_DesktopWindowMenuItem
		  
		  count = myRoot.Count - 1
		  
		  // Handle unchecking all the 'window' menus and checking a front-most listable, visible window
		  For i As Integer = 0 To count
		    If myRoot.MenuAt(i) IsA LDS_DesktopWindowMenuItem Then // Ensure the menu is a WindowMenuItem
		      w = LDS_DesktopWindowMenuItem(myRoot.MenuAt(i))
		      w.HasCheckMark = False
		      if(mDiamondHiddenWindow and  (w.specialMenuType=LDS_DesktopWindowMenuItem.specialMenuItemTypes.NOT_SPECIAL) and not w.mWindow.isShowing()) then
		        if color.IsDarkMode then
		          w.icon = LDS_DiamondNWhiteIcon
		        else
		          w.icon = LDS_DiamondNBlackIcon
		        end
		      else
		        w.Icon = nil
		      end
		      
		      // is this menu item for the front most window
		      // also, is that window listable and not minimized
		      If(app.WindowCount>0 and  w.IsWindow(app.windowAt(0)) and (w.specialMenuType=specialMenuItemTypes.NOT_SPECIAL) and (w.mWindow<>nil) and (LDS_DesktopWindowListable(w.mWindow).isShowing())) Then
		        w.HasCheckMark = True
		      End If
		    End If
		  Next
		  
		  // now check to see if we have a minimize special item, if so, can the window minimize?
		  for  childIndex as integer = 0 to myRoot.count-1
		    if(myRoot.MenuAt(childIndex) isA LDS_DesktopWindowMenuItem) then
		      w = LDS_DesktopWindowMenuItem(myRoot.MenuAt(childIndex))
		      if(w.specialMenuType = specialMenuItemTypes.Minimize) then
		        // basically the top window has to have a minimize button.  AND (either it is not an LDS_DesktopWindowListable or the top LDS_DesktopWindowListable is visible)
		        if((app.WindowCount>0) and desktopWindow(app.window(0)).HasMinimizeButton and ((not app.window(0) isa LDS_DesktopWindowListable) or (LDS_DesktopWindowListable.topWindow<>nil )))  then
		          w.Enabled = true
		          exit
		        end
		      end
		    end
		  next
		  
		  // now check to see if we have a maximize (zoom) special item, if so, can the window minimize?
		  for  childIndex as integer = 0 to myRoot.count-1
		    if(myRoot.MenuAt(childIndex) isA LDS_DesktopWindowMenuItem) then
		      w = LDS_DesktopWindowMenuItem(myRoot.MenuAt(childIndex))
		      if(w.specialMenuType = specialMenuItemTypes.Zoom) then
		        // basically the top window has to have a minimize button.  AND (either it is not an LDS_DesktopWindowListable or the top LDS_DesktopWindowListable is visible)
		        if((app.WindowCount>0) and desktopWindow(app.window(0)).HasMaximizeButton and ((not app.window(0) isa LDS_DesktopWindowListable) or (LDS_DesktopWindowListable.topWindow<>nil )))  then
		          w.Enabled = true
		          exit
		        end
		      end
		    end
		  next
		  
		  //as long as we have ANY windows then enable bring to front
		  for  childIndex as integer = 0 to myRoot.count-1
		    if(myRoot.MenuAt(childIndex) isA LDS_DesktopWindowMenuItem) then
		      w = LDS_DesktopWindowMenuItem(myRoot.MenuAt(childIndex))
		      if(w.specialMenuType = specialMenuItemTypes.BringAllToFront) then
		        if(app.WindowCount>0) then
		          w.Enabled = true
		          exit
		        end
		      end
		    end
		  next
		  
		  var mbar as DesktopMenuBar
		  var aMenu as DesktopMenuItem
		  if(app.WindowCount>0) then mbar = desktopWindow(app.window(0)).MenuBar
		  if(mbar=nil) then mbar = app.MenuBar
		  if(mbar<>nil) then
		    aMenu = mbar.child("FileMenu")
		    if(aMenu<>nil) then aMenu = aMenu.child("FileClose")
		    if(aMenu<>nil) then
		      if((app.WindowCount>0) and desktopWindow(app.window(0)).HasCloseButton)  then
		        aMenu.Enabled = true
		      end
		    end
		  end
		  
		  
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h21
		Private Shared mDiamondHiddenWindow As boolean
	#tag EndProperty

	#tag Property, Flags = &h21
		Private mWindow As LDS_DesktopWindowListable
	#tag EndProperty

	#tag Property, Flags = &h1
		Protected Shared myRoot As LDS_DesktopWindowMenuItem
	#tag EndProperty

	#tag Property, Flags = &h21
		Private specialMenuType As specialMenuItemTypes = specialMenuItemTypes.NOT_SPECIAL
	#tag EndProperty


	#tag Enum, Name = specialMenuConfiguration, Type = Integer, Flags = &h0
		none=0
		  minimize=1
		  zoom=2
		  BringToFront=4
		All=7
	#tag EndEnum

	#tag Enum, Name = specialMenuItemTypes, Flags = &h1
		NOT_SPECIAL=-1
		  RootLevel
		  Minimize
		  Zoom
		BringAllToFront
	#tag EndEnum


	#tag ViewBehavior
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="LastRowIndex"
			Visible=false
			Group="Behavior"
			InitialValue=""
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Text"
			Visible=false
			Group="Behavior"
			InitialValue=""
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="HasCheckMark"
			Visible=false
			Group="Behavior"
			InitialValue=""
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Shortcut"
			Visible=false
			Group="Behavior"
			InitialValue=""
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="AutoEnabled"
			Visible=false
			Group="Behavior"
			InitialValue=""
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Enabled"
			Visible=false
			Group="Behavior"
			InitialValue="0"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Visible"
			Visible=false
			Group="Behavior"
			InitialValue="0"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="_mName"
			Visible=false
			Group="Behavior"
			InitialValue=""
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="_mIndex"
			Visible=false
			Group="Behavior"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Icon"
			Visible=false
			Group="Behavior"
			InitialValue="0"
			Type="Picture"
			EditorType=""
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
